unit CrtSim51HW;

interface

type  Bufer   = array[0..$FFFE] of Byte;

const SIM_WR  = $03;         // zapis do RAM
      SIM_RD  = $01;         // cteni z RAM
      SIM_CLR = $FE;         // nulovani citace adresy a prechod do rezimu OnLine

var   EppBase : word;        // bazova adresa LPT
      EppStat : word;        //
      EppCont : word;        //
      EppAddr : word;        // v rezimu EPP port pro R/W adresy
      EppData : word;        // v rezimu EPP port pro R/W dat
      Size    : word;        // velikost bafru+1
      WorkBuf : ^Bufer;      // pracovni bafr

procedure OutPortB(Addr: word; Value: byte);
function  InPortB(Addr: word): byte;

procedure EppOpen(Addr: word);
procedure EppClose;
function  EppIn : byte;
procedure EppOut(Value: byte);
procedure EppSetAdr(Value: byte);

procedure SimWrite;
procedure SimRead;
function  SimVerify: boolean;



implementation
uses SysUtils;
//------------------------------------------------------------------------------
//  zapise bajt VALUE do portu ADDR
//------------------------------------------------------------------------------
procedure OutPortB(Addr: word; Value: byte); assembler;
asm
  xchg AX,DX
  out  DX,AL
end;

//------------------------------------------------------------------------------
// precte bajt z portu ADDR
//------------------------------------------------------------------------------
function InPortB(Addr: word): byte; assembler;
asm
  mov DX,AX
  in  AL,DX
end;

//------------------------------------------------------------------------------
//  inicializuje port ADDR do rezimu EPP a nastavi promenne
//------------------------------------------------------------------------------
procedure EppOpen(Addr: word);
begin
  EppBase:= Addr;                // bazova adresa Epp1
  EppStat:= EppBase+1;           //
  EppCont:= EppBase+2;           //
  EppAddr:= EppBase+3;           // v rezimu EPP port pro R/W adresu
  EppData:= EppBase+4;           // v rezimu EPP port pro R/W data (byte)
  OutPortB(EppCont, $E0);        // povolime EPP a bidirection
  OutPortB(EppBase, $00);        // na datove budece '1'
  EppSetAdr($FF);                // nastavime adresu $00
end;

//------------------------------------------------------------------------------
//  vrati port do puvodniho rezimu
//------------------------------------------------------------------------------
procedure EppClose;
begin
  OutPortB(EppCont, $00);
end;

//------------------------------------------------------------------------------
//  zapise adresu do periferie
//------------------------------------------------------------------------------
procedure EppSetAdr(Value: byte);
begin
  OutPortB(EppAddr, Value);
end;

//------------------------------------------------------------------------------
//  zapise data do periferie
//------------------------------------------------------------------------------
procedure EppOut(Value: byte);
begin
  OutPortB(EppData, Value);
end;

//------------------------------------------------------------------------------
// precte data z periferie
//------------------------------------------------------------------------------
function EppIn: byte;
begin
  Result:=InPortB(EppData);
end;

//------------------------------------------------------------------------------
//  zapise obsah bafru do simulatoru
//------------------------------------------------------------------------------
procedure SimWrite;
var i,j : Word;
begin
  EppSetAdr($FF);                               // nulovani citace adres
  EppIn;
  EppSetAdr($FE);                               // nulovani citace adres
  EppSetAdr($FF);                               // nulovani citace adres
  for i:=0 to 1000 do;                          // pauza
  EppOut(0);
  for i:=0 to $FFFF do begin
    EppOut(WorkBuf^[i]);      // zapis byte do SRAM
    for j:=0 to 100 do;
  end;
  EppSetAdr($FE);                               // OnLine;
end;

//------------------------------------------------------------------------------
//  nacte obsah simulatoru do bafru
//------------------------------------------------------------------------------
procedure SimRead;
var i : Word;
begin
  EppSetAdr($FF);                               // nulovani citace adres
  EppIn;
  EppSetAdr($FE);                               // nulovani citace adres
  EppSetAdr($FF);                               // nulovani citace adres
  for i:=0 to 100 do;                          // pauza
  EppIn;
  for i:=0 to $FFFF do WorkBuf^[i]:= EppIn;      // cteni byte ze SRAM
  EppSetAdr($FE);                               // OnLine;
end;

//------------------------------------------------------------------------------
//  porovna obsah bafru s obsahem simulatoru
//------------------------------------------------------------------------------
function SimVerify: boolean;
var i,j : Word;
    x : byte;
begin
  Result:= True;
  EppSetAdr($FF);                               // nulovani citace adres
  EppIn;
  EppSetAdr($FE);                               // nulovani citace adres
  EppSetAdr($FF);                               // nulovani citace adres
  for i:=0 to 1000 do;                          // pauza
  EppIn;
  for i:=0 to $FFFF do begin
    x:= EppIn;
    if x <> WorkBuf^[i] then Result:=False; // porovnani obsahu
    for j:=0 to 100 do;
  end;
  EppSetAdr($FE);                               // OnLine
end;

//------------------------------------------------------------------------------
end.
